import { Observable, Subject, UnaryFunction } from 'rxjs';
import { Options } from './../options';
import { AbstractCommand } from './abstract.command';
import { Command } from './command';
export declare class CreateReactCommand extends AbstractCommand implements Command {
    private options;
    static readonly TYPE: string;
    static readonly COMMAND: string;
    constructor(options: Options);
    printHelp(): void;
    process(): Observable<string>;
}
export interface LayoutClass {
    jsxFolder: string;
    cssFolder: string;
    type: any;
    layout: any;
    layoutClass: string;
    layoutTemplateFile: string;
    layoutStyleFile: string;
    layoutRef: string;
    layoutSelector: string;
    layoutTemplate: string;
}
export declare class LayoutRegistry {
    private aBaseFolders;
    private aOptions;
    private aMkdirp;
    private aLogger;
    private layoutMap;
    private layoutRegistry;
    constructor(aBaseFolders: Observable<string[]>, aOptions: Options, aMkdirp: UnaryFunction<string, Observable<string>>, aLogger: Subject<string>);
    registerLayout(aLayout: any): boolean;
    findLayoutClass(aLayout: any, aType: any): Observable<LayoutClass>;
}
