import { Observable, Subject, UnaryFunction } from 'rxjs';
import { Options } from './../options';
import { ComponentClass, ComponentRegistry } from './component.reg';
export interface LayoutClass {
    folder: string;
    component: ComponentClass;
    type: any;
    layout: any;
    mapping: any;
    layoutClass: string;
    moduleClass: string;
    layoutFile: string;
    moduleFile: string;
    layoutTemplateFile: string;
    layoutStyleFile: string;
    layoutRef: string;
    moduleRef: string;
    layoutSelector: string;
    layoutTemplate: string;
}
export declare class LayoutRegistry {
    private aBaseFolders;
    private aOptions;
    private aMkdirp;
    private aComponentRegistry;
    private aLogger;
    private layoutMap;
    private layoutRegistry;
    constructor(aBaseFolders: Observable<string[]>, aOptions: Options, aMkdirp: UnaryFunction<string, Observable<string>>, aComponentRegistry: ComponentRegistry, aLogger: Subject<string>);
    registerLayout(aLayout: any): boolean;
    findLayoutClass(aLayout: any, aMapping: any, aType: any): Observable<LayoutClass>;
}
