"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
/* Copyright IBM Corp. 2018 */
var path_1 = require("path");
var rx_compress_1 = require("../utils/rx.compress");
var constants_1 = require("./../constants");
var config_1 = require("./../utils/config");
var abstract_command_1 = require("./abstract.command");
var help_1 = require("./help");
var CompressAssetsCommand = /** @class */ (function (_super) {
    __extends(CompressAssetsCommand, _super);
    function CompressAssetsCommand(options) {
        return _super.call(this, options) || this;
    }
    CompressAssetsCommand.prototype.printHelp = function () {
        // log the command line
        console.log(CompressAssetsCommand.COMMAND, CompressAssetsCommand.TYPE, "--" + constants_1.OPTION_DATA + " <DATA>", "[--" + constants_1.OPTION_NAME + " <NAME>]", "[--" + constants_1.OPTION_PKG_DIR + " <PKG>]", "[--" + constants_1.OPTION_ROOT + " <ROOT>]", "[--" + constants_1.OPTION_VERBOSE + "]");
        // log the parameters
        console.log("--" + constants_1.OPTION_DATA + " <DATA>", ':', help_1.HELP_DATA_DIRECTORY);
        console.log("--" + constants_1.OPTION_DATA + " <DATA>", ':', help_1.HELP_DATA_DIRECTORY);
        console.log("--" + constants_1.OPTION_PKG_DIR + " <PKG>", ':', help_1.HELP_PKG_DIR);
        console.log("--" + constants_1.OPTION_NAME + " <NAME>", ':', help_1.HELP_APPLICATION_NAME);
        console.log("--" + constants_1.OPTION_VERBOSE, ':', help_1.HELP_VERBOSE);
    };
    CompressAssetsCommand.prototype.process = function () {
        // the options
        var opts = this.getOptions();
        var appName = opts.name || this.getAppName();
        var contextRoot = "/" + config_1.configTrimSlashes(opts.root || this.getContextRoot(appName));
        // logger
        var logger = this.getLogger();
        // the directories
        var dataDir = this.getDataDir();
        // name of the target directory for the main files
        var assetDir = path_1.resolve(path_1.normalize(path_1.join(dataDir, 'assets', appName)));
        // log this
        logger.next("Compressing [" + assetDir + "] ...");
        // compress
        var rxResult = rx_compress_1.rxCompressDir(assetDir);
        // ok
        return rxResult;
    };
    CompressAssetsCommand.TYPE = 'assets';
    CompressAssetsCommand.COMMAND = constants_1.CMD_COMPRESS;
    return CompressAssetsCommand;
}(abstract_command_1.AbstractCommand));
exports.CompressAssetsCommand = CompressAssetsCommand;
